// -*-c++-*-

#ifndef CXCPARAMX_SIMPLE_H
#define CXCPARAMX_SIMPLE_H

#include <memory>
#include <string>

#include <Exception/Exception.h>

namespace cxcparamx {

    using std::string;


    class simple {

    public:

	simple( int argc,  char** argv, const string& mode = "rw" );
	simple( const string& filename, int argc, char** argv, const string& mode = "rw" );

        void get( const string& name, float& value );
	void get( const string& name, double& value );
	void get( const string& name, short& value );
	void get( const string& name, int& value );
	void get( const string& name, long& value );
	void get( const string& name, bool& value );
	void get( const string& name, string& value );

	float  getf( const string& name );
	double getd( const string& name );
	short  gets( const string& name );
	int    geti( const string& name );
	long   getl( const string& name );
	bool   getb( const string& name );
	string getstr( const string& name );

        bool access( const string& name );


        struct  ParamFileImpl;
        using  pParamFileImpl = std::unique_ptr<ParamFileImpl, void(*)(ParamFileImpl*)>;

   private:

        simple( simple& ) = delete;
        simple& operator=( simple& ) = delete;

        void access_t(  const string& name );

        pParamFileImpl pf;

	string filename;
    };

}

#endif // ! CXCPARAMX_SIMPLE_H
